note
	description: "[
		
		]"
	author: "Jackie Wang"
	date: "$Date$"
	revision: "$Revision 19.05$"

class
	TEST_EXAMPLE

inherit

	ES_TEST

create
	make

feature {NONE} -- Initialization

	make
			-- initialize tests
		do
			add_boolean_case (agent t1)
			add_boolean_case (agent t2)
			add_boolean_case (agent t3)
		end

feature -- tests

	t1: BOOLEAN
		local
			a: ARRAY [CHARACTER]
			b: ARRAY [INTEGER]
			local_result: BOOLEAN
		do
			comment ("t1: test integer interval")

			Result :=
				not (across
					1 |..| 10 is i
				all
					i * i < 100
				end)
			check Result end

			Result :=
				across
					1 |..| 10 is i -- stores each integer in interval
				some
					i * i < 100
				end
			check Result end

			Result :=
				across
					1 |..| 10 as i -- cursor to each integer in interval
				some
					i.item * i.item < 100
				end
			check Result end


			local_result := True
--			Result :=
				across
					1 |..| 10 is i
				loop
					local_result := local_result and i * i <= 100
				end
			Result := local_result
		end

	t2: BOOLEAN
		local
			names: ARRAY[STRING]
		do
			comment ("t2: test array quantification")

			create names.make_empty
			names.force ("sunhye", names.count + 1)
			names.force ("jihye", names.count + 1)
			names.force ("heeyeon", names.count + 1)

			-- Boolean expression: jihye exsits in names?
			Result :=
				across
					-- 1 |..| names.count
					names.lower |..| names.upper is l_i
				some
					names[l_i] ~ "jihye"
				end

			-- Boolean expression: all names are non-empty strings.
			Result :=
				across
					-- 1 |..| names.count
					names.lower |..| names.upper is l_i
				all
					names[l_i] /~ ""
					-- names[l_i].count /= 0
					-- not names[l_i].is_empty
				end
		end

	t3: BOOLEAN
		local
			a: ARRAY[INTEGER]
			sum: INTEGER
			i: INTEGER
			exit_now: BOOLEAN 
		do
			comment ("t3: test sum")

			-- say we refuse to calculate the sum of array containing any negative numbers
			-- exit from the loop as soon as we see the first negative number
			a := <<1, 2, -3, 7, 5>>
			from
				sum := 0
				i := a.lower -- i := 1
				exit_now := False
			until
				-- a[i] < 0 or ... would not work, because in the last iteration, i is incremented to a.upper + 1
			 	-- exit from the loop as soon as exit_now becomes true!
			 	exit_now or i > a.upper -- i > a.count
			loop
				if a[i] < 0 then
					exit_now := True
				else
					sum := sum + a[i]
				end
				i := i + 1
			end
			Result := sum = 3
		end
end
