note
	description: "[
		
		]"
	author: "Jackie Wang"
	date: "$Date$"
	revision: "$Revision 19.05$"

class
	TEST_EXAMPLE

inherit

	ES_TEST

create
	make

feature {NONE} -- Initialization

	make
			-- initialize tests
		do
			add_boolean_case (agent t1)
			add_boolean_case (agent t2)
			add_boolean_case (agent t3)
		end

feature -- tests

	t1: BOOLEAN
		do
			comment ("t1: test for-all on integer interval")

			Result :=
				not (across
					1 |..| 10 is i
				all
					i * i < 100
				end)
			check Result end


			Result :=
				across
					1 |..| 10 is i -- i is integer
				some
					i * i < 100
				end
			check Result end

			Result :=
				not (across
					1 |..| 10 as i -- i is cursor to integer
				all
					i.item * i.item < 100
				end)
			check Result end
		end


	t2: BOOLEAN
		local
			names: ARRAY[STRING]
		do
			comment ("t2: test array using intevals")

			names := <<"alan", "mark", "tom">>

			Result :=
				-- 1 |..| names.count
				across
					names.lower |..| names.upper is l_i
				some
					names[l_i] ~ "mark"
				end
			check Result end

			Result :=
				across
					names is l_name -- l_name is of the member type of `names`
				some
					l_name ~ "mark"
				end
		end

	t3: BOOLEAN
		local
			numbers: ARRAY[INTEGER]
			i: INTEGER
		do
			comment ("t3: test loops")

			numbers := <<1, 3, -2, 4>>

			from
				Result := True
				i := numbers.lower
			until
				-- exit when either Result becomes false, or when i becomes too large
				not Result  or i > numbers.upper -- since indices start with 1, numbers.upper = numbers.count
			loop
--				Result := Result and numbers[i] > 0
				Result := numbers[i] > 0
				i := i + 1
			end
			-- Result is false
			Result := not Result
		end
end
